//***************************************************************************************
// BME280 Sensor
// Jed Margolin  2/1/2021.
//***************************************************************************************
// These Ports must be initialized in Main
#define SCL_POUT  P2OUT
#define SCL_BIT   BIT4
#define SCL_PDIR  P2DIR

#define SDA_POUT   P2OUT
#define SDA_PIN    P2IN
#define SDA_PDIR   P2DIR
#define SDA_BIT    BIT5
//=======================
#define IIC_ID_WRITE 0xEC    // (0x76<<1)        BMP280 device
#define IIC_ID_READ 0xED     // (0x76<<1 & 0x01

#define hum_lsb 0xFE;       // humidity byte 0      Read Only  bmpdata[7]
#define hum_msb 0xFD;       // humidity byte 1      Read Only  bmpdata[6]
#define temp_xlsb 0xFC;     // temperature byte 0   Read Only  bmpdata[5]   R,Address,Data
#define temp_lsb 0xFB;      // temperature byte 1   Read Only  bmpdata[4]
#define temp_msb 0xFA;      // temperature byte 2   Read Only  bmpdata[3]

#define bme_config 0xF5;    // configuration        Read/Write  R/W,Address;Data
#define bme_ctrl_meas 0xF4; // control measurement  Read/Write  R/W,Address;Data
#define bme_status 0xF3;    // status               Read Only
#define bme_reset 0xE0;     // reset                Write Only  /W,Address;Data
#define bme_id 0xD0;        // part id = 0x58       Read Only

unsigned char i2c_read(unsigned char);
void i2c_stop_bit(void);
void i2c_start_bit(void);
unsigned char i2c_sendbyte(unsigned char);
unsigned char i2c_getbyte(void);
unsigned char i2c_write(unsigned char, unsigned char);

void bme_init(void);
void getcal(void);
int wait_ready(void);

void wait(int);
void wait1(void);
void wait5ms(void);

// Globals
unsigned char i2c_rxdata;
unsigned char intcount;

unsigned char bmedata[8];
unsigned char caldata[6];   // bme calibration data dig T1 -T3
unsigned char humdata[8];

long signed int bme280_compensate_T(void);

unsigned char device_id;
unsigned long show_temperature, show_humidity;

unsigned short dig_T1, dig_P1;
long int dig_T2, dig_T3;
unsigned char dig_H1, dig_H3;
int dig_H2, dig_H4, dig_H5;
char dig_H6;
signed long int adc_t, adc_h, adc_temp;

int do_compensation(void);    // do compensation for temperature and humidity
void read_bme280(void);

long T, F, hextemp;
unsigned long Humidity;
//================================================
