// My TX4U
// Jed Margolin  2/1/2021

// sensor data structure
struct sensor
{
    unsigned char type;         // temperature=0x00; humidity=0x0E
    unsigned char address;      // sensor address
    unsigned char data4;        // data nybble in BCD
    unsigned char data3;        // data nybble in BCD
    unsigned char data2;        // data nybble in BCD
    unsigned char data1;        // data nybble in BCD
    unsigned char data0;        // data nybble in BCD
    unsigned char daddress;     // sensor address with parity bit Example: made by makeit(&temp1)
    unsigned char checksum;     // checksum nybble Example: made by makeit(&temp1)
};

struct sensor temp1 = {0x00,26,0x07,0x09, 0x08, 0x07, 0x09,0x00,0x00};  // 29.979 deg C  85.82 deg F
struct sensor hum1 = {0x0E,26,0x04,0x03, 0x00, 0x04, 0x03,0x00,0x00};

void makeid(struct sensor *, unsigned char);
void makeit(struct sensor * );                  // example: makeit(&temp1);
void sendit(struct sensor *, struct sensor *);  // example: sendit(&temp1, &hum1);
void send_packet(struct sensor *);

int temperature;

unsigned char mode = 0;     // modes for using interrupts
//  mode0 - make data, powerup, sendit
//  mode1 - send 8 transmissions 8 seconds apart
//  mode2 - continuous every 60 seconds

unsigned char type, address, data4, data3, data2, data1, data0;
unsigned int checksum;

unsigned int irq_count = 3;       // start right away
unsigned int count;

void temperature_bcd4(struct sensor *, unsigned int);  // from BMP sensor
void humidity_bcd(struct sensor *, unsigned int);      // example: humidity_bcd(23,&hum1);

void wait1ms(void);
void waitms(unsigned int);
void wait5ms(void);
void wait29ms(void);
void wait114ms(void);
void wait195ms(void);
void wait241ms(void);
void wait301ms(void);
void waitseconds(unsigned int);
void send_data(unsigned char);
void send_one(void);
void send_zero(void);
void send_nybble(unsigned char);
void send_byte(unsigned char);
void send_word(unsigned int);
void send_low_12bits(unsigned int);
void send_test1(void);  // test_data_1 = {0x0A0F, 0xE0FF, 0x00F4};   temp
void send_test2(void);  // test_data_2 = {0x0AEF, 0xE0FF, 0x00F2};   temp, then humidity
void send_test3(void);  // test_data_3 = temp, then humidity
void pwrup(void);
